0.9.9 API documenation: GLM_GTX_extented_min_max

| 0.9.9 API documenation

Functions
GLM_GTX_extented_min_max
Experimental extensions

## Functions
template<typename genType >
GLM_FUNC_DECL genType | fclamp (genType x, genType minVal, genType maxVal)
template<length_t L, typename T , qualifier Q>
GLM_FUNC_DECL vec< L, T, Q > | fclamp (vec< L, T, Q > const &x, T minVal, T maxVal)
template<length_t L, typename T , qualifier Q>
GLM_FUNC_DECL vec< L, T, Q > | fclamp (vec< L, T, Q > const &x, vec< L, T, Q > const &minVal, vec< L, T, Q > const &maxVal)
template<typename genType >
GLM_FUNC_DECL genType | fmax (genType x, genType y)
template<typename genType >
GLM_FUNC_DECL genType | fmin (genType x, genType y)
template<typename T >
GLM_FUNC_DECL T | max (T const &x, T const &y, T const &z)
template<typename T , template< typename > class C>
GLM_FUNC_DECL C< T > | max (C< T > const &x, typename C< T >::T const &y, typename C< T >::T const &z)
template<typename T , template< typename > class C>
GLM_FUNC_DECL C< T > | max (C< T > const &x, C< T > const &y, C< T > const &z)
template<typename T >
GLM_FUNC_DECL T | max (T const &x, T const &y, T const &z, T const &w)
template<typename T , template< typename > class C>
GLM_FUNC_DECL C< T > | max (C< T > const &x, typename C< T >::T const &y, typename C< T >::T const &z, typename C< T >::T const &w)
template<typename T , template< typename > class C>
GLM_FUNC_DECL C< T > | max (C< T > const &x, C< T > const &y, C< T > const &z, C< T > const &w)
template<typename T >
GLM_FUNC_DECL T | min (T const &x, T const &y, T const &z)
template<typename T , template< typename > class C>
GLM_FUNC_DECL C< T > | min (C< T > const &x, typename C< T >::T const &y, typename C< T >::T const &z)
template<typename T , template< typename > class C>
GLM_FUNC_DECL C< T > | min (C< T > const &x, C< T > const &y, C< T > const &z)
template<typename T >
GLM_FUNC_DECL T | min (T const &x, T const &y, T const &z, T const &w)
template<typename T , template< typename > class C>
GLM_FUNC_DECL C< T > | min (C< T > const &x, typename C< T >::T const &y, typename C< T >::T const &z, typename C< T >::T const &w)
template<typename T , template< typename > class C>
GLM_FUNC_DECL C< T > | min (C< T > const &x, C< T > const &y, C< T > const &z, C< T > const &w)

## Detailed Description

Include <glm/gtx/extented_min_max.hpp> to use the features of this extension.

Min and max functions for 3 to 4 parameters.

## Function Documentation

## ◆ fclamp() [1/3]

GLM_FUNC_DECL genType glm::fclamp | ( | genType | x,
|  | genType | minVal,
|  | genType | maxVal
| ) |  |

Returns min(max(x, minVal), maxVal) for each component in x.

If one of the two arguments is NaN, the value of the other argument is returned.

Template Parameters

  genType | Floating-point scalar or vector types.

See also
  gtx_extented_min_max

## ◆ fclamp() [2/3]

GLM_FUNC_DECL vec<L, T, Q> glm::fclamp | ( | vec< L, T, Q > const & | x,
|  | T | minVal,
|  | T | maxVal
| ) |  |

Returns min(max(x, minVal), maxVal) for each component in x.

If one of the two arguments is NaN, the value of the other argument is returned.

Template Parameters

  L | Integer between 1 and 4 included that qualify the dimension of the vector
  T | Floating-point scalar types
  Q | Value from qualifier enum

See also
  gtx_extented_min_max

## ◆ fclamp() [3/3]

GLM_FUNC_DECL vec<L, T, Q> glm::fclamp | ( | vec< L, T, Q > const & | x,
|  | vec< L, T, Q > const & | minVal,
|  | vec< L, T, Q > const & | maxVal
| ) |  |

Returns min(max(x, minVal), maxVal) for each component in x.

If one of the two arguments is NaN, the value of the other argument is returned.

Template Parameters

  L | Integer between 1 and 4 included that qualify the dimension of the vector
  T | Floating-point scalar types
  Q | Value from qualifier enum

See also
  gtx_extented_min_max

## ◆ fmax()

GLM_FUNC_DECL genType glm::fmax | ( | genType | x,
|  | genType | y
| ) |  |

Returns y if x < y; otherwise, it returns x.

If one of the two arguments is NaN, the value of the other argument is returned.

Template Parameters

  genType | Floating-point; scalar or vector types.

See also
  gtx_extented_min_max
  std::fmax documentation

## ◆ fmin()

GLM_FUNC_DECL genType glm::fmin | ( | genType | x,
|  | genType | y
| ) |  |

Returns y if y < x; otherwise, it returns x.

If one of the two arguments is NaN, the value of the other argument is returned.

Template Parameters

  genType | Floating-point or integer; scalar or vector types.

See also
  gtx_extented_min_max

## ◆ max() [1/6]

GLM_FUNC_DECL T glm::max | ( | T const & | x,
|  | T const & | y,
|  | T const & | z
| ) |  |

Return the maximum component-wise values of 3 inputs.

See also
  gtx_extented_min_max

## ◆ max() [2/6]

GLM_FUNC_DECL C<T> glm::max | ( | C< T > const & | x,
|  | typename C< T >::T const & | y,
|  | typename C< T >::T const & | z
| ) |  |

Return the maximum component-wise values of 3 inputs.

See also
  gtx_extented_min_max

## ◆ max() [3/6]

GLM_FUNC_DECL C<T> glm::max | ( | C< T > const & | x,
|  | C< T > const & | y,
|  | C< T > const & | z
| ) |  |

Return the maximum component-wise values of 3 inputs.

See also
  gtx_extented_min_max

## ◆ max() [4/6]

GLM_FUNC_DECL T glm::max | ( | T const & | x,
|  | T const & | y,
|  | T const & | z,
|  | T const & | w
| ) |  |

Return the maximum component-wise values of 4 inputs.

See also
  gtx_extented_min_max

## ◆ max() [5/6]

GLM_FUNC_DECL C<T> glm::max | ( | C< T > const & | x,
|  | typename C< T >::T const & | y,
|  | typename C< T >::T const & | z,
|  | typename C< T >::T const & | w
| ) |  |

Return the maximum component-wise values of 4 inputs.

See also
  gtx_extented_min_max

## ◆ max() [6/6]

GLM_FUNC_DECL C<T> glm::max | ( | C< T > const & | x,
|  | C< T > const & | y,
|  | C< T > const & | z,
|  | C< T > const & | w
| ) |  |

Return the maximum component-wise values of 4 inputs.

See also
  gtx_extented_min_max

## ◆ min() [1/6]

GLM_FUNC_DECL T glm::min | ( | T const & | x,
|  | T const & | y,
|  | T const & | z
| ) |  |

Return the minimum component-wise values of 3 inputs.

See also
  gtx_extented_min_max

## ◆ min() [2/6]

GLM_FUNC_DECL C<T> glm::min | ( | C< T > const & | x,
|  | typename C< T >::T const & | y,
|  | typename C< T >::T const & | z
| ) |  |

Return the minimum component-wise values of 3 inputs.

See also
  gtx_extented_min_max

## ◆ min() [3/6]

GLM_FUNC_DECL C<T> glm::min | ( | C< T > const & | x,
|  | C< T > const & | y,
|  | C< T > const & | z
| ) |  |

Return the minimum component-wise values of 3 inputs.

See also
  gtx_extented_min_max

## ◆ min() [4/6]

GLM_FUNC_DECL T glm::min | ( | T const & | x,
|  | T const & | y,
|  | T const & | z,
|  | T const & | w
| ) |  |

Return the minimum component-wise values of 4 inputs.

See also
  gtx_extented_min_max

## ◆ min() [5/6]

GLM_FUNC_DECL C<T> glm::min | ( | C< T > const & | x,
|  | typename C< T >::T const & | y,
|  | typename C< T >::T const & | z,
|  | typename C< T >::T const & | w
| ) |  |

Return the minimum component-wise values of 4 inputs.

See also
  gtx_extented_min_max

## ◆ min() [6/6]

GLM_FUNC_DECL C<T> glm::min | ( | C< T > const & | x,
|  | C< T > const & | y,
|  | C< T > const & | z,
|  | C< T > const & | w
| ) |  |

Return the minimum component-wise values of 4 inputs.

See also
  gtx_extented_min_max